import { Navigate } from "react-router-dom";
import { IOCUndeployDialog } from "../IOCUndeployDialog";
import { useStartJobMutation } from "../../../store/enhancedApi";
import { IocDetails } from "../../../store/deployApi";

interface UndeployIOCProps {
  open: boolean;
  setOpen: (value: boolean) => void;
  ioc: IocDetails;
}

export const UndeployIOC = ({ open, setOpen, ioc }: UndeployIOCProps) => {
  const [
    undeploy,
    { data: undeployment, error: unDeploymentError, isLoading, reset }
  ] = useStartJobMutation();

  if (!undeployment) {
    return (
      <IOCUndeployDialog
        open={open}
        setOpen={setOpen}
        submitCallback={undeploy}
        ioc={ioc}
        error={unDeploymentError}
        resetError={() => reset()}
        buttonDisabled={ioc.operationInProgress || isLoading}
      />
    );
  } else {
    return (
      <Navigate
        to={`/jobs/${undeployment.id}`}
        replace
      />
    );
  }
};
